/* Generated by GOB (v1.0.4) on Sat Nov 11 17:45:04 2000
   (do not edit directly) */

#define GOB_VERSION_MAJOR 1
#define GOB_VERSION_MINOR 0
#define GOB_VERSION_PATCHLEVEL 4


#line 2 "gel-text.gob"

#include "config.h"
#include <gnome.h>

#include "gel-text.h"
#include "gel-text-private.h"
/* this is just normal C code that is used in the object, the object is at the
   bottom of the file */

#include <stdio.h>
#include <string.h>

static gboolean parsed_colors = FALSE;
static GdkColor keyword_color;
static GdkColor string_color;
static GdkColor number_color;
static GdkColor comment_color;

enum {
	GOT_CHAR,
	GOT_WORD,
	GOT_STRING,
	GOT_NUMBER,
	GOT_COMMENT,
};

typedef struct _Stream Stream;
struct _Stream {
	int (*_getc)(gpointer data);
	int (*_ungetc)(int c, gpointer data);
	gpointer data;
};

static int
stream_getc(Stream *st)
{
	return st->_getc(st->data);
}

static int
stream_ungetc(int c, Stream *st)
{
	return st->_ungetc(c,st->data);
}

typedef struct _TextStreamData TextStreamData;
struct _TextStreamData {
	char *pos;
	int pushback;
};

static int
_text_stream_getc(gpointer data)
{
	int ret;
	TextStreamData *tsd = data;
	if(tsd->pushback>=0) {
		ret = tsd->pushback;
		tsd->pushback = -1;
		return ret;
	}
	if(!*(tsd->pos))
		return EOF;
	else
		return (*(tsd->pos++));
}

static int
_text_stream_ungetc(int c, gpointer data)
{
	TextStreamData *tsd = data;
	tsd->pushback = c;
	return c;
}

static int
_file_stream_getc(gpointer data)
{
	return fgetc(data);
}

static int
_file_stream_ungetc(int c, gpointer data)
{
	return ungetc(c,data);
}


static Stream *
create_file_stream(FILE *fp)
{
	Stream *st = g_new0(Stream,1);
	st->_getc = _file_stream_getc;
	st->_ungetc = _file_stream_ungetc;
	st->data = fp;
	return st;
}

static void
free_file_stream(Stream *st)
{
	g_free(st);
}

static Stream *
create_string_stream(char *string)
{
	TextStreamData *tsd = g_new0(TextStreamData,1);
	Stream *st = g_new0(Stream,1);

	st->_getc = _text_stream_getc;
	st->_ungetc = _text_stream_ungetc;
	st->data = tsd;
	
	tsd->pos = string;
	tsd->pushback = -1;

	return st;
}

static void
free_string_stream(Stream *st)
{
	g_free(st->data);
	g_free(st);
}

static char *
get_word(Stream *st, int *got_what)
{
	GString *gs;
	char *r;
	char c;
	
	if((c=stream_getc(st))==EOF)
		return NULL;
	gs = g_string_new("");

	if(c=='"') {
		*got_what = GOT_STRING;
	} else if((c>='0' && c<='9') || c=='.') {
		*got_what = GOT_NUMBER;
	} else if((c>='a' && c<='z') || (c>='A' && c<='Z') || c=='_') {
		*got_what = GOT_WORD;
	} else if(c=='#') {
		*got_what = GOT_COMMENT;
	} else {
		*got_what = GOT_CHAR;
	}
	g_string_append_c(gs,c);
	if(*got_what == GOT_CHAR)
		goto return_string;

	while((c=stream_getc(st))!=EOF) {
		switch(*got_what) {
		case GOT_STRING:
			g_string_append_c(gs,c);
			if(c == '"')
				goto return_string;
			break;
		case GOT_NUMBER:
			if((c>='0' && c<='9') || c=='.' ||
			   c=='e' || c=='E' || c=='x') {
				g_string_append_c(gs,c);
			} else {
				stream_ungetc(c,st);
				goto return_string;
			}
			break;
		case GOT_WORD:
			if((c>='a' && c<='z') ||
			   (c>='0' && c<='9') ||
			   (c>='A' && c<='Z') ||
			   c == '_') {
				g_string_append_c(gs,c);
			} else {
				stream_ungetc(c,st);
				goto return_string;
			}
			break;
		case GOT_COMMENT:
			g_string_append_c(gs,c);
			if(c == '\n')
				goto return_string;
			break;
		default: break;
		}
	}
return_string:
	r = gs->str;
	g_string_free(gs,FALSE);
	return r;
}

static const char *keywords[] = {
	"load","plugin","not","and","xor","or","while","until","for","do",
	"to","by","in","if","then","else","define","function","call",
	"return","bailout","exception","continue","break","null",
	NULL
};

static gboolean
is_keyword(char *word)
{
	int i;
	for(i=0;keywords[i];i++) {
		if(strcmp(word,keywords[i])==0)
			return TRUE;
	}
	return FALSE;
}

static int recolor_timeout_handler(gpointer data);


#line 226 "gel-text.c"
/* self casting macros */
#define SELF(x) GEL_TEXT(x)
#define SELF_CONST(x) GEL_TEXT_CONST(x)
#define IS_SELF(x) GEL_IS_TEXT(x)
#define SELF_CLASS(x) GEL_TEXT_CLASS(x)

#define SELF_GET_CLASS(x) GEL_TEXT_GET_CLASS(x)

/* self typedefs */
typedef GelText Self;
typedef GelTextClass SelfClass;

/* GTK_CLASS_TYPE for 1.2<->1.3/2.0 GTK+ compatibility */
#ifndef GTK_CLASS_TYPE
#define GTK_CLASS_TYPE(x) (GTK_OBJECT_CLASS(x)->type)
#endif /* GTK_CLASS_TYPE */

/* here are local prototypes */
static void gel_text_class_init (GelTextClass * c) G_GNUC_UNUSED;
static void gel_text_init (GelText * gt) G_GNUC_UNUSED;
static void ___3_gel_text_destroy (GtkObject * self) G_GNUC_UNUSED;
static void ___6_gel_text_insert_text (GtkEditable * self, const gchar * text, gint length, gint * position) G_GNUC_UNUSED;
static void ___7_gel_text_delete_text (GtkEditable * self, gint start_pos, gint end_pos) G_GNUC_UNUSED;
static int gel_text_find_begin_line (GelText * self, int pos) G_GNUC_UNUSED;
static int gel_text_find_end_line (GelText * self, int pos) G_GNUC_UNUSED;
static void gel_text_load_text (GelText * self, Stream * st) G_GNUC_UNUSED;
static void gel_text_recolor_queued_line (GelText * self) G_GNUC_UNUSED;

/* pointer to the class of our parent */
static GtkTextClass *parent_class = NULL;

guint
gel_text_get_type (void)
{
	static guint type = 0;

	if (!type) {
		static const GtkTypeInfo info = {
			"GelText",
			sizeof (GelText),
			sizeof (GelTextClass),
			(GtkClassInitFunc) gel_text_class_init,
			(GtkObjectInitFunc) gel_text_init,
			/* reserved_1 */ NULL,
			/* reserved_2 */ NULL,
			(GtkClassInitFunc) NULL
		};

		type = gtk_type_unique (gtk_text_get_type(), &info);
	}

	return type;
}


#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
static const typeof(&gel_text_new) new __attribute__ ((__unused__)) = gel_text_new;
#define new(args...) gel_text_new(##args)
static const typeof(&gel_text_add_mirror) add_mirror __attribute__ ((__unused__)) = gel_text_add_mirror;
#define add_mirror(args...) gel_text_add_mirror(##args)
static const typeof(&gel_text_remove_mirror) remove_mirror __attribute__ ((__unused__)) = gel_text_remove_mirror;
#define remove_mirror(args...) gel_text_remove_mirror(##args)
static const typeof(&gel_text_load_file) load_file __attribute__ ((__unused__)) = gel_text_load_file;
#define load_file(args...) gel_text_load_file(##args)
static const typeof(&gel_text_load_string) load_string __attribute__ ((__unused__)) = gel_text_load_string;
#define load_string(args...) gel_text_load_string(##args)
static const typeof(&gel_text_save_file) save_file __attribute__ ((__unused__)) = gel_text_save_file;
#define save_file(args...) gel_text_save_file(##args)
static const typeof(&gel_text_find_begin_line) find_begin_line __attribute__ ((__unused__)) = gel_text_find_begin_line;
#define find_begin_line(args...) gel_text_find_begin_line(##args)
static const typeof(&gel_text_find_end_line) find_end_line __attribute__ ((__unused__)) = gel_text_find_end_line;
#define find_end_line(args...) gel_text_find_end_line(##args)
static const typeof(&gel_text_load_text) load_text __attribute__ ((__unused__)) = gel_text_load_text;
#define load_text(args...) gel_text_load_text(##args)
static const typeof(&gel_text_recolor_queued_line) recolor_queued_line __attribute__ ((__unused__)) = gel_text_recolor_queued_line;
#define recolor_queued_line(args...) gel_text_recolor_queued_line(##args)
#else /* __GNUC__ && !__STRICT_ANSI__ */
static GtkWidget * (* new) (void) = gel_text_new;
static void (* add_mirror) (GelText * self, GelText * mirror) = gel_text_add_mirror;
static void (* remove_mirror) (GelText * self, GelText * mirror) = gel_text_remove_mirror;
static gboolean (* load_file) (GelText * self, char * fname) = gel_text_load_file;
static void (* load_string) (GelText * self, char * string) = gel_text_load_string;
static gboolean (* save_file) (GelText * self, char * fname) = gel_text_save_file;
static int (* find_begin_line) (GelText * self, int pos) = gel_text_find_begin_line;
static int (* find_end_line) (GelText * self, int pos) = gel_text_find_end_line;
static void (* load_text) (GelText * self, Stream * st) = gel_text_load_text;
static void (* recolor_queued_line) (GelText * self) = gel_text_recolor_queued_line;
#endif /* __GNUC__ && !__STRICT_ANSI__ */

/* a macro for creating a new object of our type */
#define GET_NEW ((GelText *)gtk_type_new(gel_text_get_type()))


#ifdef G_OBJECT_CLASS
static void
___finalize(GObject *obj_self)
#else /* !G_OBJECT_CLASS */
static void
___finalize(GtkObject *obj_self)
#endif /* G_OBJECT_CLASS */
{
#define __GOB_FUNCTION__ "Gel:Text::finalize"
	GelText *self = GEL_TEXT (obj_self);
	gpointer priv = self->_priv;
#ifdef G_OBJECT_CLASS
	if(G_OBJECT_CLASS(parent_class)->finalize) \
		(* G_OBJECT_CLASS(parent_class)->finalize)(obj_self);
#else /* !G_OBJECT_CLASS */
	if(GTK_OBJECT_CLASS(parent_class)->finalize) \
		(* GTK_OBJECT_CLASS(parent_class)->finalize)(obj_self);
#endif /* G_OBJECT_CLASS */
	g_free(priv);
}
#undef __GOB_FUNCTION__

static void 
gel_text_class_init (GelTextClass * c)
{
#define __GOB_FUNCTION__ "Gel:Text::class_init"
	GtkObjectClass *gtk_object_class = (GtkObjectClass*) c;
#ifdef G_OBJECT_CLASS
	GObjectClass *g_object_class = (GObjectClass*) c;
#endif /* G_OBJECT_CLASS */
	GtkEditableClass *gtk_editable_class = (GtkEditableClass *)c;

	parent_class = gtk_type_class (gtk_text_get_type ());

#line 256 "gel-text.gob"
	gtk_object_class->destroy = ___3_gel_text_destroy;
#line 280 "gel-text.gob"
	gtk_editable_class->insert_text = ___6_gel_text_insert_text;
#line 330 "gel-text.gob"
	gtk_editable_class->delete_text = ___7_gel_text_delete_text;
#line 360 "gel-text.c"
#ifdef G_OBJECT_CLASS
	g_object_class->finalize = ___finalize;
#else /* !G_OBJECT_CLASS */
	gtk_object_class->finalize = ___finalize;
#endif /* G_OBJECT_CLASS */
	return;
	c = NULL;
	gtk_object_class = NULL;
#ifdef G_OBJECT_CLASS
	g_object_class = NULL;
#endif /* G_OBJECT_CLASS */
}
#undef __GOB_FUNCTION__
#line 229 "gel-text.gob"
static void 
gel_text_init (GelText * gt)
#line 377 "gel-text.c"
{
#define __GOB_FUNCTION__ "Gel:Text::init"
	gt->_priv = g_new0 (GelTextPrivate, 1);
 {
#line 230 "gel-text.gob"

		gt->_priv->recolor_timeout = 0;
		gt->_priv->recolor_startpos = -1;
		gt->_priv->recolor_endpos = -1;
		gt->_priv->mirrors = NULL;
		gt->_priv->no_mirror = 0;
	
#line 390 "gel-text.c"
 }
	return;
	gt = NULL;
}
#undef __GOB_FUNCTION__



#line 238 "gel-text.gob"
GtkWidget * 
gel_text_new (void)
{
#define __GOB_FUNCTION__ "Gel:Text::new"
#line 404 "gel-text.c"
{
#line 240 "gel-text.gob"
	
		if(!parsed_colors) {
			gdk_color_parse("red",
					&keyword_color);
			gdk_color_parse("magenta",
					&string_color);
			gdk_color_parse("DarkGreen",
					&number_color);
			gdk_color_parse("blue",
					&comment_color);
			parsed_colors = TRUE;
		}

		return GTK_WIDGET(GET_NEW);
	}}
#line 422 "gel-text.c"
#undef __GOB_FUNCTION__

#line 256 "gel-text.gob"
static void 
___3_gel_text_destroy (GtkObject * self)
#line 428 "gel-text.c"
#define PARENT_HANDLER(___self) \
	{ if(GTK_OBJECT_CLASS(parent_class)->destroy) \
		(* GTK_OBJECT_CLASS(parent_class)->destroy)(___self); }
{
#define __GOB_FUNCTION__ "Gel:Text::destroy"
#line 256 "gel-text.gob"
	g_return_if_fail (self != NULL);
#line 256 "gel-text.gob"
	g_return_if_fail (GTK_IS_OBJECT (self));
#line 438 "gel-text.c"
{
#line 258 "gel-text.gob"
	
		GelText *gt = GEL_TEXT(self);
		g_free(gt->filename);
		if(gt->_priv->recolor_timeout)
			gtk_timeout_remove(gt->_priv->recolor_timeout);
		if(* GTK_OBJECT_CLASS (parent_class)->destroy)
			(* GTK_OBJECT_CLASS (parent_class)->destroy) (self);
	}}
#line 449 "gel-text.c"
#undef __GOB_FUNCTION__
#undef PARENT_HANDLER

#line 267 "gel-text.gob"
void 
gel_text_add_mirror (GelText * self, GelText * mirror)
{
#define __GOB_FUNCTION__ "Gel:Text::add_mirror"
#line 267 "gel-text.gob"
	g_return_if_fail (self != NULL);
#line 267 "gel-text.gob"
	g_return_if_fail (GEL_IS_TEXT (self));
#line 267 "gel-text.gob"
	g_return_if_fail (mirror != NULL);
#line 267 "gel-text.gob"
	g_return_if_fail (GEL_IS_TEXT (mirror));
#line 466 "gel-text.c"
{
#line 269 "gel-text.gob"
	
		if(!g_list_find(self->_priv->mirrors,mirror))
			self->_priv->mirrors = g_list_prepend(self->_priv->mirrors,mirror);
	}}
#line 473 "gel-text.c"
#undef __GOB_FUNCTION__

#line 274 "gel-text.gob"
void 
gel_text_remove_mirror (GelText * self, GelText * mirror)
{
#define __GOB_FUNCTION__ "Gel:Text::remove_mirror"
#line 274 "gel-text.gob"
	g_return_if_fail (self != NULL);
#line 274 "gel-text.gob"
	g_return_if_fail (GEL_IS_TEXT (self));
#line 274 "gel-text.gob"
	g_return_if_fail (mirror != NULL);
#line 274 "gel-text.gob"
	g_return_if_fail (GEL_IS_TEXT (mirror));
#line 489 "gel-text.c"
{
#line 276 "gel-text.gob"
	
		self->_priv->mirrors = g_list_remove(self->_priv->mirrors,mirror);
	}}
#line 495 "gel-text.c"
#undef __GOB_FUNCTION__

#line 280 "gel-text.gob"
static void 
___6_gel_text_insert_text (GtkEditable * self, const gchar * text, gint length, gint * position)
#line 501 "gel-text.c"
#define PARENT_HANDLER(___self,___text,___length,___position) \
	{ if(GTK_EDITABLE_CLASS(parent_class)->insert_text) \
		(* GTK_EDITABLE_CLASS(parent_class)->insert_text)(___self,___text,___length,___position); }
{
#define __GOB_FUNCTION__ "Gel:Text::insert_text"
#line 280 "gel-text.gob"
	g_return_if_fail (self != NULL);
#line 280 "gel-text.gob"
	g_return_if_fail (GTK_IS_EDITABLE (self));
#line 280 "gel-text.gob"
	g_return_if_fail (text != NULL);
#line 280 "gel-text.gob"
	g_return_if_fail (length >= 0);
#line 280 "gel-text.gob"
	g_return_if_fail (position != NULL);
#line 517 "gel-text.c"
{
#line 285 "gel-text.gob"
	
		GelText *gt = GEL_TEXT(self);
		int find_ends = TRUE;
		int orig_pos = *position;

		if(gt->_priv->recolor_startpos!=-1) {
		       if(*position < gt->_priv->recolor_startpos ||
			  *position > gt->_priv->recolor_endpos+1) {
			       recolor_queued_line(gt);
		       } else
			       find_ends = FALSE;
		}

		if(find_ends)
			gt->_priv->recolor_startpos = find_begin_line(gt,*position);

		(* GTK_EDITABLE_CLASS (parent_class)->insert_text)
			(self,text,length,position);

		if(find_ends)
			gt->_priv->recolor_endpos = find_end_line(gt,*position);
		else
			gt->_priv->recolor_endpos += length;

		if(gt->_priv->recolor_startpos >= gt->_priv->recolor_endpos) 
			gt->_priv->recolor_startpos = -1;
		else if(!gt->_priv->recolor_timeout)
			gt->_priv->recolor_timeout = 
				gtk_timeout_add(1000,recolor_timeout_handler,gt);

		if(gt->_priv->no_mirror == 0) {
			GList *li;
			for(li=gt->_priv->mirrors;li;li=li->next) {
				GelText *t = li->data;
				int pos = orig_pos;
				/* prevent mirroring again from there since
				   we are already doing the mirror */
				t->_priv->no_mirror++;
				gtk_editable_insert_text(GTK_EDITABLE(t),
							 text,length,&pos);
				t->_priv->no_mirror--;
			}
		}
	}}
#line 564 "gel-text.c"
#undef __GOB_FUNCTION__
#undef PARENT_HANDLER

#line 330 "gel-text.gob"
static void 
___7_gel_text_delete_text (GtkEditable * self, gint start_pos, gint end_pos)
#line 571 "gel-text.c"
#define PARENT_HANDLER(___self,___start_pos,___end_pos) \
	{ if(GTK_EDITABLE_CLASS(parent_class)->delete_text) \
		(* GTK_EDITABLE_CLASS(parent_class)->delete_text)(___self,___start_pos,___end_pos); }
{
#define __GOB_FUNCTION__ "Gel:Text::delete_text"
#line 330 "gel-text.gob"
	g_return_if_fail (self != NULL);
#line 330 "gel-text.gob"
	g_return_if_fail (GTK_IS_EDITABLE (self));
#line 581 "gel-text.c"
{
#line 334 "gel-text.gob"
	
		GelText *gt = GEL_TEXT(self);

		if(gt->_priv->recolor_startpos!=-1 &&
		   (end_pos <= gt->_priv->recolor_startpos ||
		    start_pos > gt->_priv->recolor_endpos-1)) {
			recolor_queued_line(gt);
		}

		gt->_priv->recolor_startpos = find_begin_line(gt,start_pos);

		(* GTK_EDITABLE_CLASS (parent_class)->delete_text)
			(self,start_pos,end_pos);

		gt->_priv->recolor_endpos = find_end_line(gt,start_pos);

		if(gt->_priv->recolor_startpos >= gt->_priv->recolor_endpos) 
			gt->_priv->recolor_startpos = -1;
		else if(!gt->_priv->recolor_timeout)
			gt->_priv->recolor_timeout = 
				gtk_timeout_add(1000,recolor_timeout_handler,gt);

		if(gt->_priv->no_mirror == 0) {
			GList *li;
			for(li=gt->_priv->mirrors;li;li=li->next) {
				GelText *t = li->data;
				/* prevent mirroring again from there since
				   we are already doing the mirror */
				t->_priv->no_mirror++;
				gtk_editable_delete_text(GTK_EDITABLE(t),
							 start_pos,end_pos);
				t->_priv->no_mirror--;
			}
		}
	}}
#line 619 "gel-text.c"
#undef __GOB_FUNCTION__
#undef PARENT_HANDLER

#line 370 "gel-text.gob"
gboolean 
gel_text_load_file (GelText * self, char * fname)
{
#define __GOB_FUNCTION__ "Gel:Text::load_file"
#line 370 "gel-text.gob"
	g_return_val_if_fail (self != NULL, (gboolean )0);
#line 370 "gel-text.gob"
	g_return_val_if_fail (GEL_IS_TEXT (self), (gboolean )0);
#line 370 "gel-text.gob"
	g_return_val_if_fail (fname != NULL, (gboolean )0);
#line 634 "gel-text.c"
{
#line 372 "gel-text.gob"
	
		FILE *fp;
		if(fname && (fp=fopen(fname,"r"))) {
			Stream *st = create_file_stream(fp);
			load_text(self,st);
			free_file_stream(st);
			fclose(fp);
			g_free(self->filename);
			self->filename = g_strdup(fname);
			return TRUE;
		} else
			return FALSE;
	}}
#line 650 "gel-text.c"
#undef __GOB_FUNCTION__

#line 386 "gel-text.gob"
void 
gel_text_load_string (GelText * self, char * string)
{
#define __GOB_FUNCTION__ "Gel:Text::load_string"
#line 386 "gel-text.gob"
	g_return_if_fail (self != NULL);
#line 386 "gel-text.gob"
	g_return_if_fail (GEL_IS_TEXT (self));
#line 386 "gel-text.gob"
	g_return_if_fail (string != NULL);
#line 664 "gel-text.c"
{
#line 388 "gel-text.gob"
	
		Stream *st = create_string_stream(string);
		load_text(self,st);
		free_string_stream(st);
	}}
#line 672 "gel-text.c"
#undef __GOB_FUNCTION__

#line 394 "gel-text.gob"
gboolean 
gel_text_save_file (GelText * self, char * fname)
{
#define __GOB_FUNCTION__ "Gel:Text::save_file"
#line 394 "gel-text.gob"
	g_return_val_if_fail (self != NULL, (gboolean )0);
#line 394 "gel-text.gob"
	g_return_val_if_fail (GEL_IS_TEXT (self), (gboolean )0);
#line 394 "gel-text.gob"
	g_return_val_if_fail (fname != NULL, (gboolean )0);
#line 686 "gel-text.c"
{
#line 396 "gel-text.gob"
	
		FILE *fp;
		if(fname && (fp=fopen(fname,"w"))) {
			char *chars;
			chars = gtk_editable_get_chars(GTK_EDITABLE(self),
						       0,-1);
			if(chars) {
				int len;
				if(fputs(chars,fp) == EOF) {
					g_free(chars);
					fclose(fp);
					return FALSE;
				}
				len = strlen(chars);
				if(len==0 || chars[len-1]!='\n')
					fputs("\n",fp);
			}
			g_free(chars);
			fclose(fp);
			return TRUE;
		} else
			return FALSE;
	}}
#line 712 "gel-text.c"
#undef __GOB_FUNCTION__

#line 422 "gel-text.gob"
static int 
gel_text_find_begin_line (GelText * self, int pos)
{
#define __GOB_FUNCTION__ "Gel:Text::find_begin_line"
#line 422 "gel-text.gob"
	g_return_val_if_fail (self != NULL, (int )0);
#line 422 "gel-text.gob"
	g_return_val_if_fail (GEL_IS_TEXT (self), (int )0);
#line 724 "gel-text.c"
{
#line 424 "gel-text.gob"
	
		int i;
		GtkText *text = GTK_TEXT(self);
		for(i=pos-1;i>=0;i--) {
			char c = GTK_TEXT_INDEX(text,i);
			if(c=='\n') break;
		}
		return i+1;
	}}
#line 736 "gel-text.c"
#undef __GOB_FUNCTION__

#line 434 "gel-text.gob"
static int 
gel_text_find_end_line (GelText * self, int pos)
{
#define __GOB_FUNCTION__ "Gel:Text::find_end_line"
#line 434 "gel-text.gob"
	g_return_val_if_fail (self != NULL, (int )0);
#line 434 "gel-text.gob"
	g_return_val_if_fail (GEL_IS_TEXT (self), (int )0);
#line 748 "gel-text.c"
{
#line 436 "gel-text.gob"
	
		int i;
		GtkText *text = GTK_TEXT(self);
		int len = gtk_text_get_length(text);
		for(i=pos;i<len;i++) {
			char c = GTK_TEXT_INDEX(text,i);
			if(c=='\0' || c=='\n') return i;
		}
		return i;
	}}
#line 761 "gel-text.c"
#undef __GOB_FUNCTION__

#line 447 "gel-text.gob"
static void 
gel_text_load_text (GelText * self, Stream * st)
{
#define __GOB_FUNCTION__ "Gel:Text::load_text"
#line 447 "gel-text.gob"
	g_return_if_fail (self != NULL);
#line 447 "gel-text.gob"
	g_return_if_fail (GEL_IS_TEXT (self));
#line 447 "gel-text.gob"
	g_return_if_fail (st != NULL);
#line 775 "gel-text.c"
{
#line 449 "gel-text.gob"
	
		GtkWidget *w;
		char *word;
		int word_type;

		w = GTK_WIDGET(self);

		gtk_text_freeze(GTK_TEXT(self));
		while((word = get_word(st,&word_type))) {
			switch(word_type) {
			case GOT_CHAR:
				gtk_text_insert(GTK_TEXT(self),NULL,NULL,NULL,word,1);
				break;
			case GOT_WORD:
				if(is_keyword(word))
					gtk_text_insert(GTK_TEXT(self), NULL,
							&keyword_color, NULL,
							word, strlen(word));
				else
					gtk_text_insert(GTK_TEXT(self), NULL,
							NULL, NULL,
							word, strlen(word));
				break;
			case GOT_STRING:
				gtk_text_insert(GTK_TEXT(self), NULL,
						&string_color, NULL,
						word, strlen(word));
				break;
			case GOT_NUMBER:
				gtk_text_insert(GTK_TEXT(self), NULL,
						&number_color, NULL,
						word, strlen(word));
				break;
			case GOT_COMMENT:
				gtk_text_insert(GTK_TEXT(self), NULL,
						&comment_color, NULL,
						word, strlen(word));
				break;
			default: break;
			}
			g_free(word);
		}
		gtk_text_thaw(GTK_TEXT(self));
	}}
#line 822 "gel-text.c"
#undef __GOB_FUNCTION__

#line 494 "gel-text.gob"
static void 
gel_text_recolor_queued_line (GelText * self)
{
#define __GOB_FUNCTION__ "Gel:Text::recolor_queued_line"
#line 494 "gel-text.gob"
	g_return_if_fail (self != NULL);
#line 494 "gel-text.gob"
	g_return_if_fail (GEL_IS_TEXT (self));
#line 834 "gel-text.c"
{
#line 496 "gel-text.gob"
	
		int pos;
		char *chars;
		if(self->_priv->recolor_startpos == -1)
			return;
		pos = gtk_editable_get_position(GTK_EDITABLE(self));

		gtk_editable_set_position(GTK_EDITABLE(self),
					  self->_priv->recolor_startpos);

		gtk_text_freeze(GTK_TEXT(self));

		chars = gtk_editable_get_chars(GTK_EDITABLE(self),
					       self->_priv->recolor_startpos,
					       self->_priv->recolor_endpos);
		(* GTK_EDITABLE_CLASS (parent_class)->delete_text)
			(GTK_EDITABLE(self),
			 self->_priv->recolor_startpos,
			 self->_priv->recolor_endpos);

		load_string(self,chars);
		g_free(chars);

		gtk_text_thaw(GTK_TEXT(self));
		gtk_editable_set_position(GTK_EDITABLE(self),pos);

		self->_priv->recolor_startpos = -1;

		if(self->_priv->recolor_timeout) {
			gtk_timeout_remove(self->_priv->recolor_timeout);
			self->_priv->recolor_timeout = 0;
		}
	}}
#line 870 "gel-text.c"
#undef __GOB_FUNCTION__


#if (!defined __GNUC__) || (defined __GNUC__ && defined __STRICT_ANSI__)
/*REALLY BAD HACK
  This is to avoid unused warnings if you don't call
  some method.  I need to find a better way to do
  this, not needed in GCC since we use some gcc
  extentions to make saner, faster code */
static void
___gel_text_really_bad_hack_to_avoid_warnings(void)
{
	((void (*)(void))new)();
	((void (*)(void))add_mirror)();
	((void (*)(void))remove_mirror)();
	((void (*)(void))load_file)();
	((void (*)(void))load_string)();
	((void (*)(void))save_file)();
	((void (*)(void))find_begin_line)();
	((void (*)(void))find_end_line)();
	((void (*)(void))load_text)();
	((void (*)(void))recolor_queued_line)();
	___gel_text_really_bad_hack_to_avoid_warnings();
}
#endif /* !__GNUC__ || (__GNUC__ && __STRICT_ANSI__) */


#line 531 "gel-text.gob"

static int
recolor_timeout_handler(gpointer data)
{
	GelText *gt = data;
	gt->_priv->recolor_timeout = 0;

	gel_text_recolor_queued_line(gt);
	
	return FALSE;
}

#line 911 "gel-text.c"
